// GOROKUDlg.h : wb_[ t@C
//
// UPDATE: 20050830 (yatou)

#if !defined(AFX_GOROKUDLG_H__E2D0514A_6EA3_45B3_B2BE_5E17AD8F9C05__INCLUDED_)
#define AFX_GOROKUDLG_H__E2D0514A_6EA3_45B3_B2BE_5E17AD8F9C05__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Goroku_Const.h"
#include "YAO.h"


//-------------------------------------------------
// \
//-------------------------------------------------

// ރR[h
typedef struct CATEGORY_RECORD
{
	YAOTag	wordTableId;							// Pe[uID
	char	wordTableName[kCATEGORY_LEN_MAX];		// Pe[u̖O
} CATEGORY_RECORD;

// PꃌR[h
typedef struct WORD_RECORD
{
	char	title[kTITLE_LEN_MAX];	// ^Cg 
	char	body[kBODY_LEN_MAX];	// {
} WORD_REDORD;

/////////////////////////////////////////////////////////////////////////////
// CGOROKUDlg _CAO

class CGOROKUDlg : public CDialog
{
// \z
public:
	// VKPe[uID߂B
	YAOStatus GetNewWordTableID( YAOTag * outNewWordTableId );
	// Pe[uID擾
	YAOStatus GetWordTableID( long inCategoryTableIndex, YAOTag * outWordTableId );
	// Pe[u̖Ou
	YAOStatus ReplaceWordTableName( long inCategoryTableIndex, char * inNewWordTableName );
	// Pe[u폜
	YAOStatus RemoveWordTable( int inCategoryIndex );
	// ^OƃCfbNX烁^f[^擾B
	YAOStatus GetMetadataFromTagIndex( YAO_FILE * ioFile, YAOTag inTag, long inIndex);
	// inMetaDatäʒũf[^inBuff̃f[^ɒuB
	YAOStatus ReplaceData( YAO_FILE * ioFile, void * inBuff, long inDataLen );
	// R{{bNXXVB
	void UpdateComboBox();
	// Xg{bNXXVB
	void UpdateListBox();	
	// Xg{bNXɕݒ
	void DrawListBox( LPDRAWITEMSTRUCT lpDIS );
	// []ꂽꍇ̏
	BOOL DoKeyDown( void );
	// []ꂽꍇ̏
	BOOL DoKeyUp( void );
	CGOROKUDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CGOROKUDlg)
	enum { IDD = IDD_GOROKU_DIALOG };
	CListBox	m_ListView;
	CComboBox	m_ComboCategory;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CGOROKUDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CGOROKUDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonCategorynew();
	afx_msg void OnButtonCategorydel();
	afx_msg void OnButtonCategorymod();
	afx_msg void OnButtonWordnew();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnSelchangeComboCategory();
	afx_msg void OnButtonWordmod();
	afx_msg void OnButtonWorddel();
	afx_msg void OnButtonClipboard();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_GOROKUDLG_H__E2D0514A_6EA3_45B3_B2BE_5E17AD8F9C05__INCLUDED_)
