// TYPE: C
// PRJ: YAO
// PGM: YAO
// VER: 1.2.1
// USES: Visual C++ 6.0
// CREATE: 20040126 (iwai)
// UPDATE: 20041216 (yamamoto, sugawara)
// UPDATE: 20050831 (shiina, yatou)
//////////////////////////////////////////////////
// 20041216 version 1.1.0 STLp~BC̃bp[p~BSʓICŏB
// 20050624 version 1.2.1 WindowsˑWCu֐pďB
//                        ݂̃^f[^(ʏ́uJgv)YAO_FILEɕێȂ
//                        삷悤ɎdlύXBANZX[hwł悤ɂȂB

#ifndef __YAO_H__
#define __YAO_H__

#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

//**************************************
// 萔E^
//**************************************



#define kYAOVersion					 1	// YAO ̃o[W

// f[^^
#define YAOStatus	long				// YAO ̃G[^
#define YAOTag		long				// YAO ̃^O\


#define kMemberNotFound (-1)			// oւ̃|C^̏lB
#define kTagNotFound	(-1)			// ^OIuWFNgւ̃|C^̏lB
#define kEntryPointTag	(-1)			// Gg[|Cgp^OB

// YAO ̃ANZX[h
#define kYAO_ReadWrite				 0  // ǂݏp
#define kYAO_ReadOnly				 1  // ǂݎp

// Ԃl
#define kYAO_Success				 0	// 
#define kYAO_Failure				-1	// s
#define kYAO_FileIO_Err				-2  // t@Co͂̃G[
#define kYAO_NoCurrent				-3  // Jg
#define kYAO_MemberNotFound			-4  // oȂ
#define kYAO_TagNotFound			-5  // ^OIuWFNgȂ
#define kYAO_FileIsReadOnly			-6  // ǂݎp[hŏ݂sƂ


// YAO Ɋi[ꂽf[^Ɋւ
typedef struct YAO_METADATA
{
	YAOTag	dataTag;				// ̃f[^f[^Q̃^O(ʎq)
	long	length;					// ̃f[^̒
	long	filePointer;			// ̃f[^̃t@C擪̃ItZbgl
	long	previousMemberPointer;	// Õo̊i[ʒu
	long	nextMemberPointer;		// ̃o̊i[ʒu
	long	previousTagPointer;		// Õ^OIuWFNg̊i[ʒu
	long	nextTagPointer;			// ̃^OIuWFNg̊i[ʒu
	char	reserved[8];			// gp̗\
} YAO_METADATA;


// YAO t@C̏i[\
typedef struct YAO_FILE
{
	FILE* filePointer;
	YAO_METADATA currentMetaData;	// Jg
	bool currentExist;				// Jg݂邩
	long accessMode;				// YAO ̃ANZX[h		
} YAO_FILE;


// YAO t@C̃wb_ (512 Bytes)
typedef struct YAO_FILE_HEADER
{
	char	signature[4];		// "YAO"̕
	short	version;			// YAO t@C̃o[W
	char	reserved[506];		// gp̗\
} YAO_FILE_HEADER;






//**************************************
// ֐
//**************************************

//------------------------------------------------
// ֐ : YAO_Create
// @\ : YAO t@CV쐬ĊJ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//------------------------------------------------
// 20050912 mod (shiina, yatou) fopengp悤ύX
//                              YAO_FILEԂlɕύX
//                              ԂlYAOStatusɕύX
YAOStatus YAO_Create( const char * inFilePath, YAO_FILE * outFile );

//------------------------------------------------
// ֐ : YAO_Open
// @\ : YAO t@CJ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//------------------------------------------------
// 20050912 mod (shiina, yatou) fopengp悤ύX
//                              YAO_FILEԂlɕύX
//                              ANZX[hwł悤ɕύX
//                              ԂlYAOStatusɕύX
YAOStatus YAO_Open( const char * inFilePath, long inAccessMode, YAO_FILE * outFile );

//-------------------------------------------------
// O : YAO_Close
// @\ : YAO t@C
//-------------------------------------------------
// 20050912 mod (shiina, yatou) fclosegp悤ύX
//                              YAO_FILË̗JsȂ悤ɂ
void YAO_Close( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_AddData
// @\ : w^OɃf[^ǉ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) AddMemberObjAddTagObjɕ
//                              inDataBuffŌɓn悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_AddData( YAO_FILE * ioFile, YAOTag inTag, long inDataLen, void * inDataBuff );

//------------------------------------------------
// ֐ : YAO_InsertData
// @\ : f[^Jg̑Oɑ}
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_NoCurrent		... Jg
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) Jg̑ÖʒuɃf[^}悤ɕύX
//                              inDataBuffŌɓn悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_InsertData( YAO_FILE * ioFile, long inDataLen, void * inDataBuff );

//------------------------------------------------
// ֐ : YAO_RemoveData
// @\ : Jg̈ʒuɂf[^폜
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_NoCurrent		... Jg
//        kYAO_FileIsReadOnly	... ǂݎp[h
//------------------------------------------------
// 20050912 mod (shiina, yatou) Jg̃f[^폜悤ɕύX
//                              ǂݎp[hȂΒɏI悤ɕύX
YAOStatus YAO_RemoveData( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_GetData
// @\ : Jg̃f[^擾
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃f[^擾悤ɕύX
YAOStatus YAO_GetData( YAO_FILE * ioFile, long inBufferLen, void * outBuff );

//------------------------------------------------
// ֐ : YAO_GetDataLength
// @\ : Jg̃f[^̒擾
// Ԓl : Jg̃f[^̒Ԃ
//        G[Jg -1 Ԃ
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̃f[^̒擾悤ɕύX
long YAO_GetDataLength( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_FirstMember
// @\ : w^O̍ŏ̃oɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... w^OȂ
//------------------------------------------------
// 20050831 mod (shiina, yatou) ֐FindFirstMembergp悤ɕύX
YAOStatus YAO_FirstMember( YAO_FILE * ioFile, YAOTag inTag );

//------------------------------------------------
// ֐ : YAO_NextMember
// @\ : ̃oɈړ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ̃oȂ
//        kYAO_NoCurrent		... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̎̃oɈړ悤ɕύX
//                              ֐FindNextMembergp悤ɕύX
YAOStatus YAO_NextMember( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_PreviousMember
// @\ : ÕoɈړ
// Ԓl : kYAO_Success			... 
//        kYAO_Failure			... s
//        kYAO_FileIO_Err		... t@Co̓G[
//        kYAO_MemberNotFound	... ÕoȂ
//        kYAO_NoCurrent		... Jg
//------------------------------------------------
// 20050831 mod (shiina, yatou) Jg̑ÕoɈړ悤ɕύX
//                              ֐FindPreviousMembergp悤ɕύX
YAOStatus YAO_PreviousMember( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_FirstTag
// @\ : ŏ̃^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_TagNotFound	... 1^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_FirstTag( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_NextTag
// @\ : ̃^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//        kYAO_TagNotFound	... ̃^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_NextTag( YAO_FILE * ioFile );

//------------------------------------------------
// ֐ : YAO_PreviousTag
// @\ : Õ^OIuWFNgɈړ
// Ԓl : kYAO_Success		... 
//        kYAO_Failure		... s
//        kYAO_FileIO_Err	... t@Co̓G[
//        kYAO_NoCurrent	... Jg
//        kYAO_TagNotFound	... Õ^O
//------------------------------------------------
// 20050831 add (shiina, yatou)
YAOStatus YAO_PreviousTag( YAO_FILE * ioFile );

#endif
